﻿// Daily (Japanese) Candlestick Defintion
// By Austin Gaster
// www.ezCandlesticks.com

var version = "2.0.0.0"; // August 2008
//var server3 = "http://www.ezcandlesticks.com/lounge/feed_versiontest.php"; // For testing this will return version 3.0.0.0 as current
//var server4 = "http://bezcandlesticks.com"; // Let's simulate a bad response
var server1 = "http://feeds.feedburner.com/ezCandlesticksDefinitions";
var server2 = "http://www.ezcandlesticks.com/lounge/feed_definitions.php";
var URL = server1;
var backUp= false;
var gadgetDownload ="http://www.ezcandlesticks.com/lounge/modules.php?name=Downloads&d_op=viewdownload&cid=1";
var homeURL="http://www.ezcandlesticks.com/lounge/modules.php?name=Google_Gadget_Pages";

	options.putDefaultValue("firstInstall",true);
	options.putDefaultValue("UID",new Date().getTime());
  options.putDefaultValue("operName",framework.runtime.osName);
  options.putDefaultValue("specialsTitle","default"); // This is how we will check for new Specials content
  options.putDefaultValue("newSpecial",true); // This will be to turn NEW grahpic on/off

  options.putDefaultValue("updateFlag", "off"); // default starting value

var viewCheck = 0;
var http = null;
var currentIndex;
var noAnswerTimer = null; // Timeout type
var updateDelayTimer = null; // Timeout type - For delaying Update Notice
var dailyTimer = null; // Interval type
var retryTimer = null; // Interval type
var animTimer = null; // Interval type - For spinner

var anim = null;

options.putDefaultValue("newColor", '#000000') ; // For title and text color
options.putDefaultValue("mnewColor", '#FF0000') ; // For mouseover color
options.putDefaultValue("opacity", 255);
var isBg1Checked = 1; var isBg2Checked = 0; var isBg3Checked = 1; var isBg4Checked = 1; var isBg5Checked = 1;

function AddCustomMenuItems(menu) { 

  var sub_item = menu.AddPopup (strBG); // Create Background Choice menu
  sub_item.AddItem (strBG1, isBg1Checked ? 0 : gddMenuItemFlagChecked, swapBackground1);
  sub_item.AddItem (strBG2, isBg2Checked ? 0 : gddMenuItemFlagChecked, swapBackground2);
  sub_item.AddItem (strBG3, isBg3Checked ? 0 : gddMenuItemFlagChecked, swapBackground3);
  sub_item.AddItem (strBG4, isBg4Checked ? 0 : gddMenuItemFlagChecked, swapBackground4);
  if (onMac == 1) {
  sub_item.AddItem (strBG5, gddMenuItemFlagGrayed, 0); // Custom Background unavailable on Macintosh
  }
    else {
    sub_item.AddItem (strBG5, isBg5Checked ? 0 : gddMenuItemFlagChecked, swapBackground5);
    }

  menu.AddItem(strRefresh, gddMenuItemFlagGrayed, OnMenuItem_Refresh); // Start out with these options disabled
  menu.AddItem(strUpdate, gddMenuItemFlagGrayed, OnMenuItem_Update);  //
  var isOnline = framework.system.network.online // The menu gets built on every call. This method allows for
  if (isOnline) {                                                   //  immediate menu reaction to online status
   menu.SetItemStyle(strUpdate, !gddMenuItemFlagGrayed);   // Reverse the status of the item (Enable)
   menu.SetItemStyle(strRefresh, !gddMenuItemFlagGrayed);  // Reverse the status of the item (Enable)
  }

    menu.AddItem(strHelpTitle, 0, OnMenuItem_showHelp); 
}

function OnMenuItem_Refresh(item_text) {
 if (viewCheck == 1) {
  plugin.CloseDetailsView();
 }
  view_onOpen(); 
}

function OnMenuItem_Update(item_text) { // Need to disable check for update with no connection
   if ((enableUpdate) &&  (latestversionArray[currentIndex] > version)) { 
     updateClick();
     }
    else alert (strNoUpdate+version);
    return;                         
    alert (strCantUpdate);  // This is actually handled by disabling menu now
}

function view_onOptionChanged() {
  if (options.getValue("opacity") < 20) {
  options.putValue("opacity", 255);
  }
  main_div.opacity = options.getValue("opacity");
  title.color = options.getValue("newColor");
  symbol_name.color = options.getValue("newColor");
  symbol_name.overColor = options.getValue("mnewColor");
}
 
function view_onClose() { // This tells database gadget has been closed
	var f=new statServer();      // Database will delete this entry
	f.post(statURL,options.getValue("UID"),"closed",options.getValue("operName"));
} 

function view_onOpen() {  
  plugin.onAddCustomMenuItems = AddCustomMenuItems; 
  clearInterval(dailyTimer); // Clear all timers to be safe
  dailyTimer = null;
  clearInterval(updateDelayTimer);
  updateDelayTimer = null;
  clearInterval(retryTimer);
  retryTimer = null;
  clearInterval(animTimer);
  animTimer = null;
  clearTimeout(noAnswerTimer);
  noAnswerTimer = null;
  URL = server1; //Without this, the random keeps adding incremently
  checkMac();  // Is Gadget on a Macintosh?
  var isOnline = framework.system.network.online // Will this pass on a Mac?
  if (isOnline) {
  enableUpdates = true;
  getFeed();
  }
  else {
   noInternet(); 
  }
}

function serverTimedOut() {
    clearTimeout(noAnswerTimer); 
    noAnswerTimer = null;
		if (backUp == false) {	
      backUp = true;
		  backupServer();
			} 
			else {
			backUp = false;
			URL = server1;
			noServerResponse (); // Delivers error message, starts retryTimer
			}
}

function backupServer() {
  if (backUp == true) { 
   URL = server2;
  backupnotice.visible = true;
    getFeed();
  }
	else {	// false
	backUp = false;
   URL = server1;
  noServerResponse();
	}
}

function noInternet() { // Call when isOnline fails
  connectionProblem = strNotOnline;
  noConnectionAction();
}

function noServerResponse () { // Call when isOnline passes, but no server response
  connectionProblem = strFailDetail;
  noConnectionAction();
}

function noConnectionAction() { // Performs actions needed to communicate what type of connection error
    stopAnimation();
    if(animTimer) {
      clearInterval(animTimer); 
      animTimer = null;    
      } 
  currentIndex = 0; 
  symbol_name.visible = true;
  titleArray = new Array();
  linkArray = new Array();
  descArray = new Array();
  loading.visible = false; 
  backupnotice.visible = false;
  symbol_name.innerText = strFail;
  descArray[currentIndex] = connectionProblem;
  titleArray[currentIndex] = strMsgLink;
  linkArray[currentIndex] = homeURL;
  enableUpdate = false;
  retryTimer = setInterval( "view_onOpen()",   1000 * 60 * 60 * 10 ); // Check for connection every 10 minutes
}

function getFeed() {
  clearTimeout(noAnswerTimer); // Reset the timer
  noAnswerTimer = null;
  noAnswerTimer = setTimeout (serverTimedOut, 50000);     // 60 seconds - long enough for slow connections?
//  noAnswerTimer = setTimeout (noServerResponse, 50000);  // This one bypasses backup server routine -4 testing
  symbol_name.visible = false;
  todaypic.visible = false;
  currentIndex = 0; 
  titleArray = new Array();
  linkArray = new Array();
  descArray = new Array();
  pubArray = new Array();
  latestversionArray = new Array();
  pictureLinkArray = new Array();
  pageTypeArray = new Array();
  http = new XMLHttpRequest();
  URL = (URL+="?r="+Math.random());
  try { 
    http.open("GET", URL, true); 
  } 
  catch (e) { 
    http = null; 
    return;
  }
  http.onreadystatechange = OnReceivedData;
  try { 
    http.send(); 
  }
  catch(e) {  
  }
}

function OnReceivedData() {
  if (http.readyState == 1)  //  If True - Server answered - let's talk
    animateLoading();
    if (http.readyState != 4) { //  Server is NOT finished - Keep waiting
    return;
    }
// We break out when readyState is 4 - server has finished
  clearTimeout(noAnswerTimer); // Stop the timer before it fires
  noAnswerTimer = null;
    if (http.status != 200) {  //  If status NOT 200 Request NOT successful - fail goes here
			if (backUp == false) {	// Try a backup url brfore completely giving up
      backUp = true;
		  backupServer();
			} 
			else  { 
			backUp = false;
			URL = server1;
			noServerResponse(); // Delivers error message, starts retryTimer
			}
		}
		else { 
		letsGo();
		}
}

// here down is success
function letsGo () {  // Populate arrays with data
 var title, link, desc, latestversion, picturelink, pagetype;
  var doc = new DOMDocument();
  doc.loadXML(http.responseText);
  var elem = doc.getElementsByTagName("item");
  for(var i = 0;i < elem.length ;i++) {
    if (elem != null && elem.length > 0) {
      for (var node = elem[i].firstChild; node != null; node = node.nextSibling) {
       if (node.nodeName == "pubDate") {
         pubDate = node.firstChild.nodeValue;  
          pubArray.push(pubDate);
         }
        if (node.nodeName == "title") {
          title = node.firstChild.nodeValue;  
          titleArray.push(title);
         }
        if (node.nodeName == "link") {
          link = node.firstChild.nodeValue; 
          linkArray.push(link);
        }
        if (node.nodeName == "description") {
          desc = node.firstChild.nodeValue;
          descArray.push(desc);
        }
        if (node.nodeName == "latestversion") {
          latestversion = node.firstChild.nodeValue;
          latestversionArray.push(latestversion);
        }
        if (node.nodeName == "picturelink") {
          pictureLink = node.firstChild.nodeValue;
          pictureLinkArray.push(pictureLink);
        }
        if (node.nodeName == "pagetype") {
          pageType = node.firstChild.nodeValue;
          pageTypeArray.push(pageType);
        }
      }
    }
// Here is where we could intercept malformed response
  }
    backupnotice.visible = false;
    backUp = false; // Resets our tracker
    stopAnimation();
    if(animTimer) {
      clearInterval(animTimer); 
      animTimer = null;    
      } 
// We need to compare the Specials title with our stored specialsTitle to check for new content
  if (titleArray[1] != options.getValue("specialsTitle")) { // If I ever add a channel I'll need to make sure Array is correct
  options.putValue("specialsTitle", titleArray[1]);
  options.putValue("newSpecial",true);
  }
  else {
  options.putValue("newSpecial",false);
  }
//
  if (latestversionArray[currentIndex] > version) { // We need to check for update at at this point.
//  updateAlert(); 
  delayTimer();
  }
  enableUpdate = true; // Enables user to select Check for Update menu item -Decedant remove when certain all is ok
  getPicture(); // Symbol graphic
  populateMain(); // Fill in main view
  checkPage(); // Swaps Special / Symbol Buttons
  callStats(); // After we have recieved this, now let's tell stat server we are online
  dailyTimer = setInterval( "view_onOpen()", 1000 * 60 * 60 * 6 ); //Check for new feed every six hours
}

function populateMain() {
  view.caption = titleArray[currentIndex]; // The caption in minimized view bar and across top of detail view
  stopAnimation();
  symbol_name.visible = true;
  symbol_name.innerText = titleArray[currentIndex];
}

function item_Click() { // User clicked on main window, title area
if (viewCheck == 1) {  // We're using a varible to track clicks to open/close view with single clicks
   plugin.CloseDetailsView(); 
   viewCheck = 0;
  } 
  else showDetails();
}

function onDetailsViewFeedback(detailsViewFlags) {
  if (detailsViewFlags == gddDetailsViewFlagNone) { // The user/system closed the details view
     viewCheck = 0; 
  }
 else if (detailsViewFlags == gddDetailsViewFlagToolbarOpen) { // User clicked on the title of the details view    
  viewCheck = 0;
    var winShell = new ActiveXObject("Shell.Application");   // This will open a broswer to encyclopedia entry
// This is possibly redundant now- leaving until testing verifies
			if (options.getValue("updateFlag") == "on") { 
			winShell.ShellExecute(gadgetDownload);  // This will change details view title link
    	winShell = null;
			}
			else {
			winShell.ShellExecute(linkArray[currentIndex]);  
			winShell = null;
			} 
  }
}

function nextClick() { // Occurs on user clicking Specials / Symbols button
  currentIndex = (++currentIndex==titleArray.length)?0:currentIndex;
  checkPage();  // Swaps Special / Symbol Buttons
  getPicture(); // Swaps symbol image
  populateMain();
   if (viewCheck == 1){
   showDetails();
   }
  if (options.getValue("newSpecial")) {     // New ad...
  new_green.visible = true;							    	// Show the "New" image and...
  options.putValue("newSpecial",false); // Change the tracker
  }
}

function checkPage() { // Swaps Special / Symbol Buttons

  if (options.getValue("newSpecial")) {  // Show / Hide "New" image
    new_green.visible = true;			
    }
  else {
  new_green.visible = false;			
  }

  if (pageTypeArray[currentIndex] == "coupon") {   // "coupon" is in the feed, and is how we are checking what
  btn_specials.visible = false;        // type of page is currently displayed and swapping images accordingly
  btn_symbols.visible = true;        //  "coupon" will always have to be in the feed
}
  else {
  btn_specials.visible = true;
  btn_symbols.visible = false;
  }
}

function showDetails () {  
  var details = new DetailsView();
  snippet = descArray[currentIndex];
  details.html_content = true;
  details.SetContent(undefined, undefined, snippet, false, 0);
  plugin.showDetailsView(details, titleArray[currentIndex], gddDetailsViewFlagToolbarOpen, onDetailsViewFeedback); 
   viewCheck = 1;
}

function animateLoading() {
  loading.visible = true;
  animTimer = setInterval( "animateRewind()", 1011 );
}

function animateRewind() {
  anim = beginAnimation("animate()",0,360,1010);
}

function animate() {
  loading.rotation = event.value;
}

function stopAnimation() {
  if(animTimer) {
    clearInterval(animTimer); 
    animTimer = null;
  }
  if (anim) {
    cancelAnimation(anim);
    anim = null;
  }
  loading.visible = false;
}

function launchURL(){
  var winShell = new ActiveXObject("Shell.Application"); 
  winShell.ShellExecute("http://ezcandlesticks.com"); 
  winShell = null;
}

